<template>
  <div class="form-wrapper">
      <el-form ref="formName" :rules="rules" :model="form" class="form-box">
        <el-form-item>
          <el-row>
            <el-col :span="8">
              <el-form-item label="房间号：" label-width="135px" class="forms" prop="roomNumber">
                <el-input  v-model="form.roomNumber" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>  
            <el-col :span="8">
              <el-form-item label="开始直播时间：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="结束直播时间：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
          </el-row>
          <el-row> 
            <el-col :span="8">
              <el-form-item label="人数：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="开始直播时间2：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="结束直播时间2：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
          </el-row>
          <el-row> 
            <el-col :span="8">
              <el-form-item label="贵宾席价钱：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="开始使用时间：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="结束使用时间：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
          </el-row>
           <el-row> 
            <el-col :span="8">
              <el-form-item label="电话：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="开始使用时间：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="结束使用时间：" label-width="135px" class="forms" prop="recipientPhone">
                <el-input  v-model="form.recipientPhone" style="width: 200px"></el-input>   
              </el-form-item>
            </el-col>
          </el-row>
        </el-form-item>
      </el-form>
    <div class="listBox">
        <div class="listBoxTop">
            <div class="listBoxTop-left">
                <i class="iconfont icon-querylist myicon"></i>
                <span>商品明细：</span>
            </div>
            <div class="listBoxRight">
                <div class="button-head" @click="addRow" ><i class="icon-xinzeng iconfont button-head-icon icon-add"></i>添加</div>
                <div class="button-head" @click="delData" ><i class="el-icon-minus"></i>移除</div>
            </div>
        </div>
        <el-table
            ref="multipleTable"
            :data="form.itemList"
            style="width: 100%"
            @selection-change="handleSelectionChange"
            border>
            <el-table-column
              type="selection"
              fixed="left"
              width="55">
            </el-table-column>
            <el-table-column
                label="商品编号"
                align="center"
                width="120">
                <template slot-scope="scope">
                    <el-input 
                      v-model="scope.row.skuId" 
                      @input="changeSkuId(scope.row.skuId,scope.$index)" 
                      placeholder=""
                      clearable>
                    </el-input>
                </template>
            </el-table-column>
            <el-table-column
                label="商品名称"
                align="center"
                width="200">
                <template slot-scope="scope">
                    <el-select
                        v-model="scope.row.skuName"
                        filterable
                        remote
                        placeholder=""
                        @change="skuIdChange(scope.$index,scope.row)"
                        :remote-method="skuNameRemote"
                        :loading="loading"
                        clearable>
                        <el-option
                            v-for="item in skuNames"
                            :key="item.id"
                            :label="item.skuName"
                            :value="item.skuName">
                        </el-option>
                    </el-select>
                </template>
            </el-table-column>
            <el-table-column
                prop="skuModel"
                label="规格"
                align="center"
                width="120">
            </el-table-column>
            <el-table-column
                prop="unit"
                label="单位"
                align="center"
                width="120">
            </el-table-column>
            <el-table-column
                label="采购数"
                align="center"
                width="150">
                <template slot-scope="scope">
                  <el-input-number 
                    v-model="scope.row.purchaseQty" 
                    :step="1" 
                    :min="0"
                    :precision="0"
                    size="mini" 
                    controls-position="right"
                    >
                  </el-input-number>
                </template>
            </el-table-column>
            <el-table-column
                label="采购单价"
                align="center"
                width="150">
                <template slot-scope="scope">
                   <el-input-number 
                    v-model="scope.row.purchasePrice" 
                    size="mini" placeholder="0.00"
                    :controls="false" >
                  </el-input-number>
                </template>
            </el-table-column>
            <el-table-column
                prop="buyingPrice"
                label="采购参考价"
                :formatter="show"
                align="center"
                width="120">
            </el-table-column>
            <el-table-column
                label="税率"
                align="center"
                width="120">
                <template slot-scope="scope">
                    <el-select v-model="scope.row.taxRate*100+'%'">
                        <el-option label="0%" value="0"></el-option>
                        <el-option label="3%" value="0.03"></el-option>
                        <el-option label="5%" value="0.05"></el-option>
                        <el-option label="9%" value="0.09"></el-option>
                        <el-option label="10%" value="0.10"></el-option>
                        <el-option label="13%" value="0.13"></el-option>
                        <el-option label="16%" value="0.16"></el-option>
                    </el-select>
                </template>
            </el-table-column>
            <el-table-column
                prop="amount"
                label="总金额"
                :formatter="show"
                align="center"
                width="120">
            </el-table-column>
            <el-table-column
                label="折扣率"
                align="center"
                width="150">
                <template slot-scope="scope">
                   <el-input-number v-model="scope.row.discount" size="mini" placeholder="0.00" :controls="false" ></el-input-number>
                </template>
            </el-table-column>
            <el-table-column
                prop="previousPurchasePrice"
                label="最新采购价"
                :formatter="show"
                align="center"
                width="120">
            </el-table-column>
            <el-table-column
                prop="finishInventoryQty"
                label="库存"
                align="center"
                width="120">
            </el-table-column>
            <el-table-column
                label="期望到货日期"
                align="center"
                width="225">
                <template slot-scope="scope">
                    <el-date-picker
                        v-model="scope.row.expectedDeliveryDate"
                        type="date"
                        value-format="yyyy-MM-dd"
                        size="small"
                        :picker-options="pickerOptions"
                        placeholder="选择日期">
                    </el-date-picker>
                </template>
            </el-table-column>
            <el-table-column
                label="采购说明"
                align="center"
                width="200">
                <template slot-scope="scope">
                    <el-input  v-model="scope.row.itemMemo"></el-input>
                </template>
            </el-table-column>
        </el-table>
    </div>
    <div class="button-box">
      <el-button type="primary" @click="addPurchaseApprovalOrder('formName')">提交</el-button>
    </div>
  </div>
   
</template>
<script>

export default {
    name:'homeShow',
    components:{
      
    },
    data() {
      return {
         form:{
          roomNumber:'',
          startLiveTime:'',
          endLiveTime:'',
          peopleNumber:'',
          startTime:'',
          endTime:'',
          vipPrice:'',
          telephone:'',

          billOrganizationId:'',
          billOrganizationName:'',
          deliveryType:'',
          expressDelivery:'',
          expressDeliveryNo:'',
          includeTax:'',
          invoiceType:'',
          itemList:[],
          latestReceiveTime:'',
          payType:'',
          purchaseType:null,
          qualityTesting:null,
          recipientAddressCityId:'',
          recipientAddressCountyId:'',
          recipientAddressLine:'',
          recipientAddressProvinceId:'',
          recipientName:'',
          recipientPhone:'',
          supplierId:'',
          supplierName:'',
          urgentLevel:'',
          warehouseId:'',
          warehouseName:'',
        },
        province:[],
        city:[],
        county:[],
        skuNames:[],
        options:[],
        value: [],
        timeout:null,
        list: [],
        multipleSelection:[],
        num:'',
        loading: false,
        supplierId:'',
        supplierName:[],
        SettlementUnitName:[],
        warehouseId:'',
        warehouseName:[],
        skuId:'',
        rejectreason:'',
        rejectdialog:false,
        id:'',
        type:'0',
        radio:0,
        name:'',
       
        forms:{
          appointReceive:null,
          billOrganizationId:'',
          billOrganizationName:'',
          deliveryType:'',
          expressDelivery:'',
          expressDeliveryNo:'',
          includeTax:'',
          invoiceType:'',
          itemList:[],
          latestReceiveTime:'',
          payType:'',
          purchaseType:null,
          qualityTesting:null,
          recipientAddressCityId:'',
          recipientAddressCountyId:'',
          recipientAddressLine:'',
          recipientAddressProvinceId:'',
          recipientName:'',
          recipientPhone:'',
          supplierId:'',
          supplierName:'',
          urgentLevel:'',
          warehouseId:'',
          warehouseName:'',
        },
        rules:{
          urgentLevel:[
            { required:true, message: '选择紧急程度', trigger:'blur'}
          ],
          invoiceType:[
            { required:true, message: '选择发票类型', trigger:'blur'}
          ],
          billOrganizationName:[
             { required:true, message: '请选择结算单位名称', trigger:'blur'}
          ],
          deliveryType:[
             { required:true, message: '请选择到货类型', trigger:'blur'}
          ],
          expressDelivery:[
             { required:true, message: '请选择是否快递', trigger:'blur'}
          ],
          expressDeliveryNo1:[
             { message: '请输入快递单号', trigger:'blur'}
          ],
          expressDeliveryNo:[
             { required:true, message: '请输入快递单号', trigger:'blur'}
          ],
          includeTax:[
             { required:true, message: '请选择是否含税', trigger:'blur'}
          ],
          latestReceiveTime:[
             { required:true, message: '请选择最晚入库时间', trigger:'blur'}
          ],
          latestReceiveTime1:[
             { message: '请选择最晚入库时间', trigger:'blur'}
          ],
          payType:[
             { required:true, message: '请选择采购方式', trigger:'blur'}
          ],
          purchaseType:[
             { required:true, message: '请选择采购类型', trigger:'blur'}
          ],
          qualityTesting:[
             { required:true, message: '请输入是否进行质量检测', trigger:'blur'}
          ],
          qualityTesting1:[
             { message: '请输入是否进行质量检测', trigger:'blur'}
          ],
          recipientAddressProvinceId:[
             { required:true, message: '请输入收货地址', trigger:'blur'}
          ],
          recipientName:[
             { required:true, message: '请输入收货人姓名', trigger:'blur'}
          ],
          recipientPhone:[
            { required:true, message: '请输入收货人联系方式', trigger:'blur'},
          ],
          supplierName:[
             { required:true, message: '请输入供应商名称', trigger:'blur'}
          ],
          appointReceive:[
            { required: true, message: '请选择是否到货预约',trigger: 'blur'}
          ],
          appointReceive1:[
            { message: '请选择是否到货预约',trigger: 'blur'}
          ],
          warehouseName:[
             { required:true, message: '请输入库房名称', trigger:'blur'}
          ],
          warehouseName1:[
              { message: '请输入库房名称', trigger:'blur'}
          ]
        },
        list: {
          buyingPrice:'',
          discount:'',
          expectedDeliveryDate:'',
          itemMemo:'',
          previousPurchasePrice:'',
          purchasePrice:'',
          purchaseQty:'',
          skuId:'',
          skuModel:'',
          skuName:'',
          taxRate:'',
          unit:'',
          amout:'',
          finishInventoryQty:'',
          rowNum:'',
        },
        skuIds:[],
        pickerOptions: {
          disabledDate(time) {
            return time.getTime() < Date.now();
          },
        }
      }
    },
    created(){
      
    },
    methods: {
      supplierRemote(query){
        this.loading = true;
        var storage=window.localStorage;
        var UserInfo=storage.getItem("UserInfo");
        var userPosts=JSON.parse(UserInfo).userPosts;
        var organizationId=userPosts[0].organizationId;
        if(this.form.purchaseType==0){
          if(query){
            getOrganizationSupplier(organizationId,{name:query}).then(res=>{
              this.loading = false
              if(res.code=='000000'){
                this.supplierName=res.data
              }
            })
          }
        }else{
          if(query){
            getSetupOrganization(query).then(res=>{
              this.loading = false;
              if(res.code=='000000'){
                this.supplierName=res.data
              }
            })
          }
        }
      },
      changeSupplierName(val){
        this.form.supplierName=val.name;
        this.form.supplierId=val.id;
      },
      SettlementUnitRemote(query){
        this.loading = true
        if(query){
          organizationListName({name:query}).then(res=>{
            this.loading = false
            if(res.code=='000000'){
              this.SettlementUnitName=res.data
            }
          })
        }
      },
      changeBillOrganizationName(val){
        this.form.billOrganizationName=val.name;
        this.form.billOrganizationId=val.id;
      },
      warehouseRemote(query){
        this.loading = true;
        var storage=window.localStorage;
        var UserInfo=storage.getItem("UserInfo");
        var userPosts=JSON.parse(UserInfo).userPosts;
        var organizationId=userPosts[0].organizationId
        if(query){
            getWarehouseName({name:query,organizationId:organizationId}).then(res=>{
              this.loading = false
              if(res.code=='000000'){
                this.warehouseName=res.data;
              }
            })
        }
      },
      ChangeDeliveryType(val){
        this.form.warehouseName='';
      },
      changeWarehouseName(val){
        if(val){
          this.form.warehouseName=val.name;
          this.form.warehouseId=val.id;
          if(val.provinceId==0){
            this.form.recipientAddressProvinceId='';
            this.form.recipientAddressCityId='';
            this.form.recipientAddressCountyId='';
            this.form.recipientAddressLine='';
          }else{
            this.getcity(val.provinceId);
            this.getcounty(val.cityId,val);
          }
          if(val.warehouseContactDTOList.length>0){
            this.form.recipientName=val.warehouseContactDTOList[0].name;
            this.form.recipientPhone=val.warehouseContactDTOList[0].phone;
          }
        }
      },
      ChangePurchaseType(val){
        this.form.supplierName='';
        this.warehouseName=[];
        this.form.purchaseType=val;
      },
      toggleSelection(rows) {
        if (rows) {
          rows.forEach(row => {
            this.$refs.multipleTable.toggleRowSelection(row);
          });
        } else {
          this.$refs.multipleTable.clearSelection();
        }
      },
      handleSelectionChange(val) {
        this.multipleSelection = val;
      },
      changeSkuId(skuId,index){
        this.getGoodsInventory(skuId,index);
        this.timeout = setTimeout(() => {
          if(skuId!=''){
            getManagementInfo(skuId).then(res=>{
              if(res.code=='000000'){
                if(res.data==''){
                  this.form.itemList[index]= this.form.itemList[index];
                }else{
                  for(let key in res.data){
                    this.form.itemList[index][key]=res.data[key];
                  }
                }
              }
            })
          }
        }, 3000 * Math.random());
      },
      show(row,column){
        let changeData='';
        if(column.property=='previousPurchasePrice'){
          if(row.previousPurchasePrice!=''&&row.previousPurchasePrice!=undefined){

            return changeData='￥'+Number(row.previousPurchasePrice).toFixed(4);
          }else{
            let previousPurchasePrice=0;
            return changeData='￥'+previousPurchasePrice.toFixed(4);
          }
        }
        if(column.property=='buyingPrice'){
          if(row.buyingPrice!=''&&row.buyingPrice!=undefined){
            return changeData='￥'+row.buyingPrice.toFixed(4);
          }
        }
        if(column.property=='amount'){
          if(row.purchaseQty!=undefined&&row.purchasePrice!=undefined){
            return changeData='￥'+(row.purchaseQty*row.purchasePrice).toFixed(4);
          }else{
            let amount=0;
            return changeData='￥'+amount.toFixed(4);
          }
        }
      },
      skuNameRemote(query){
        this.loading = true
          if(query){
            getManagementInfoName(query).then(res=>{
              this.loading = false
              if(res.code=='000000'){
                this.skuNames=res.data;
              }
            })
          }
      },
      skuIdChange(index,row){
        var skuNames=[];
        skuNames=this.skuNames.filter((item,index)=>{
          return row.skuName==item.skuName;
        });
        if(skuNames.length==0){
          this.form.itemList[index]= this.form.itemList[index];
        }else{
          getLastPurchasePrice(skuNames[0].skuId).then(res=>{
            if(res.code=='000000'){
              this.form.itemList[index]['previousPurchasePrice']=res.data;
            }
          });
          this.getGoodsInventory(skuNames[0].skuId,index);
          for(let key in skuNames[0]){
            this.form.itemList[index][key]=skuNames[0][key];
          }
        }
      },
      getGoodsInventory(skuId,index){
        if(skuId!=''&&this.form.warehouseId!=''){
            this.skuIds.push(skuId);
            getGoodsInventory({
              skuId:this.skuIds,
              warehouseId:this.form.warehouseId
            }).then(res=>{
              if(res.code=='000000'){
                if(res.data.length==0){
                  this.form.itemList[index]['finishInventoryQty']=0;
                }else{
                  this.form.itemList[index]['finishInventoryQty']=res.data[0].availableQty;
                }
              }
            })
          }
      },
      addPurchaseApprovalOrder(formName){
        this.$refs[formName].validate((valid) => {
          if(valid) {
             addPurchaseApproval(this.form).then(res=>{
              if(res.code=='000000'){
                this.$message({
                  message: '保存成功',
                  type: 'success'
                });
                this.$refs[formName].clearValidate();
                 this.timeout = setTimeout(() => {
                    this.form=this.forms;
                  }, 3000 * Math.random());
              }
            })
          } else {
            return false;
          }
        });      
      },
      addRow () {
        var list={
          buyingPrice:'',
          discount:'',
          expectedDeliveryDate:'',
          itemMemo:'',
          previousPurchasePrice:'',
          purchasePrice:'',
          purchaseQty:'',
          skuId:'',
          skuModel:'',
          skuName:'',
          taxRate:'',
          unit:'',
          amout:'',
          finishInventoryQty:'',
          rowNum:''
        };
        list.rowNum=this.form.itemList.length;
        this.form.itemList.push(list)
      },
      delData() {
        for (let i = 0; i < this.multipleSelection.length; i++) {
          let val = this.multipleSelection;
          val.forEach((val, index) => {
            this.form.itemList.forEach((v, i) => {
              if (val.rowNum === v.rowNum) {
                this.form.itemList.splice(i, 1)
              }
            })
          })
        }
        this.$refs.multipleTable.clearSelection()
      },
      getProvinces(){
        provinces_based_id().then(res=>{
          if(res.code=='000000'){
            this.province = res.data;
          }
        })
      },
      getcity(id){
        subs(id).then(res=>{
          if(res.code=='000000'){
            this.city = res.data;
          }
        })
      },
      getcounty(id,val){
        subs(id).then(res=>{
          if(res.code=='000000'){
            this.county = res.data;
            if(val){
              this.form.recipientAddressProvinceId=val.provinceId;
              this.form.recipientAddressCityId=val.cityId;
              this.form.recipientAddressCountyId=val.countyId;
              this.form.recipientAddressLine=val.addressLine;
            }
          }
        })
      },
      onCityChange(val){
        this.form.recipientAddressCountyId='';
        this.getcounty(val);
      },
      onProvincesChange(val){
        this.form.recipientAddressCityId='';
        this.getcity(val);
      },
      close(){
        close();
      },
    }
  }
</script>

<style scoped lang="less">
    @color:#f3f3f3;
    .form-wrapper{
        border-right:1px solid #e4e4e4;
        border-left:1px solid #e4e4e4;
        border-bottom:1px solid #e4e4e4;
        .form-box{
        .el-row{
            margin:25px 0 0 50px; 
            /deep/.forms{
              /deep/.el-form-item__content{
                  display: inline-block;
                  width: 53%;
                  margin-left:0 !important;
                  .el-input__inner{
                  
                  }
              }
            }
            /deep/.addressBox{
              /deep/.el-form-item__content{
                  width: 90%;
              }
            }
        }
        }
    }
    .listBox {
      font-size: 12px;
      background-color:@color;
      border: 1px solid #e4e4e4;
      clear: both;
      margin: 20px 0 0 0;
      .listBoxTop {
        display: flex;
        justify-content: space-between;
        .listBoxTop-left{
          .myicon{
            margin-left: 20px;
            font-weight: bold;
            font-size: 20px;
          }
          span {
            margin-left: 5px;
            font-size: 14px;
            color: #303133;
            line-height: 50px;
          }
        }
      }
      .listBoxRight {
        display: flex;
        justify-content: flex-end;
        align-items: center;
        margin-right: 10px;
        .button-head{
          width: 80px;
          height: 30px;
          margin-right: 10px;
          border:1px solid #d1d1d1;
          cursor:pointer;
          background-color: #fff;
          line-height: 30px;
          border-radius: 3px;
          display: flex;
          justify-content: center;
          align-items: center;
          .button-head-icon{
            margin-right: 5px;
          }
          .icon-add{
            font-size: 12px;
          }
        }
        .button-head:hover{
          background-color: #f3f3f3;
        }
        .el-button {
          width: 80px;
          height: 30px;
          margin-top: 10px;
        }
      }
      .el-table {
        margin-top: -2px;
        .el-button {
          font-size: 12px;
        }
        /deep/.el-input--small {
          .el-input__inner{
            width: 85%;
          }
        }
        /deep/.el-select{
          width: 100%;
        }
      }
    }
    .button-box{
      width: 90%;
      margin: 20px auto 50px;
      display: flex;
      justify-content: flex-end;
    }
</style>
